
_G[gTable] = {};

local aTmpVal = gTable;
cm.SetupTable(_G[aTmpVal]);


-- Called on Init
_G[gTable].OnInit = function(pObj)
	pObj.mState = 1;
	pObj.mCsData:SetVal("SpawnCnt", 0);
end

-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)
end


-- Called on a update
_G[gTable].OnUpdate = function(pObj)

	if pObj.mState == 2 then
		if not pObj.mAlpha:AncIsChanging() then
			pObj.mIsDone = true;
		end
	end

end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

	if pName == "" then

      local aCount = pObj.mCsData:GetInt("SpawnCnt");
      local aSpStr = string.format("SpawnObject%d", aCount + 1);
      if not cm.SpawnObject(pObj, 0, pObj.mSmPos, aSpStr) then
         return true;
      end

      pObj:StartFadeRects(PhFadeAnotherTimeShort);
      pObj:StopParticleEmission(false);
      pObj.mCurCell = pObj.mCurCell + 1;

      aCount = aCount + 1;
      if aCount < 4 then
         pObj.mCsData:SetVal("SpawnCnt", aCount);
         IcPlaySample("PH_SFX_OBJ_PICKUP");
         return true;
      end

		pObj.mState = pObj.mState + 1;
		pObj:SetActive(0, pPolyNum, false);
		IcPlaySample("PH_SFX_OBJ_PICKUP");
		return true;

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

	return false;

end


-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)


	pG:PushState();
	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRpos = pObj.mSmPos;
	local aRect = aImg:GetCelRect(pObj.mCurCell);

	if (pObj.mState == 2) then
		pG:SetColorizeImages(true);
		pG:SetColor(Color(255, 255, 255, pObj.mAlpha:AncGetVal()));
	end
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);

   pG:PopState();
end


-- Called on moused
_G[gTable].OnMoused =  function(pObj)
	print(2+2);
end

-- Called on Unmoused
_G[gTable].OnUnMoused =  function(pObj)
	print(2+2);
end



